import statistics
#program pro výpočet rozsahu osy, který opravuje přijaté chyby a vybere správnou hodnotu
def range_calculator(data):
    try:
        if type(data) !=  type(list()): return 0 #vypni pokud není správný typ
        if len(data) == 0: return 0 #vypni, pokud nejsou žádná data

        # převedení vstupních dat na abs hodotu
        data_c = []
        for x in range(len(data)):
            data_c.append(abs(data[x]))
        
        data_c.sort() # seřazení vstupních dat podle velikosti
        data_c.remove(0) # odstranění nuly

        # vytvoří rozdíly sousedících hodnot pro vytřvoření mediánu rozdílů
        rozdily = []
        for x in range(len(data_c)-1):
            rozdily.append(data_c[x+1] - data_c[x])
        median_rozdilu = statistics.median(rozdily) #medián rozdílů, pro zjištění trendu

        treshold = 2
        index_to_pop = []
        for x in range(len(rozdily)):
            if rozdily[x] > (median_rozdilu * treshold): #pokud jsou nějaké hodnoty větší než median * treshold(2), označ je za chybné pro odstranění
                index_to_pop.append(x+1) #zapíše idexy, které se mají vymazat z data_c

        tr = 0.8 # treshodl pro počet zbývajících dat 80%
        if len(index_to_pop) != 0:      
            burden = index_to_pop[-1]/(len(data_c)-1) # výpočet "zatížení", zbývající data po vymazání všech dat od posledního extrému
            if burden < tr:
                return 0
        #smazání chybných dat
        for i in range(len(index_to_pop)-1, -1, -1):
            if i == len(index_to_pop)-1:
                for j in range(len(data_c)-1,index_to_pop[i] -1, -1):
                    data_c.pop(j)
                continue
            data_c.pop(index_to_pop[i])
        data_c = max(data_c)
        return data_c
    except:
        return 0